myRaidAddon = LibStub("AceAddon-3.0"):NewAddon("myRaidAddon", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0")
-- Ovenfor laves addon
-- AceGUI kan lave widgets og containers
local AceGUI = LibStub("AceGUI-3.0"); 
local self=myRaidAddon

-- Create a container frame
f = AceGUI:Create("ScrollFrame");

local spec_width = 50;
local name_width = 200;
local raid_min_level = 80;
local raid_num_tanks = 0;
local raid_num_dps = 0;
local raid_num_healers = 0;
local test_num = 0;
local raid_data = {};
local raid_makeup = "";
local keywords = {"register", "unregister"}
local prefix_spec = "spec";

-- Chat prefixes
local prefix_whispers = "!raidinfo"
local prefix_answers = "pura>"

titler = AceGUI:Create("SimpleGroup");
titler:SetLayout("Flow");
titler:SetFullWidth(true);

label_raid = AceGUI:Create("Label");
label_raid:SetText("Raid member");
label_raid:SetWidth(name_width);
titler:AddChild(label_raid);

label_tank = AceGUI:Create("Label");
label_tank:SetText("Tank");
label_tank:SetWidth(spec_width);
titler:AddChild(label_tank);

label_heal = AceGUI:Create("Label");
label_heal:SetText("Healer");
label_heal:SetWidth(spec_width);
titler:AddChild(label_heal);

label_dps = AceGUI:Create("Label");
label_dps:SetText("DPS");
label_dps:SetWidth(spec_width);
titler:AddChild(label_dps);

-- Add til frame
f:AddChild(titler);
---------------

label_raidmax = AceGUI:Create("Label");
label_raidmax:SetText("Raid maximum: ");
label_raidmax:SetWidth(name_width);



-- Create scrollframe to list people in
fscroll = AceGUI:Create("ScrollFrame");

-- kan bruges til at sende beskeder (f.eks. LFG hvert minut)
-- self:ScheduleEvent("MyAddon_ReactToExplosion", 1) -- fires off MyAddon_ReactToExplosion in 1 seconds
-- self:ScheduleRepeatingEvent("MyAddon_Spasm", 1) -- spams every second.


-- Frame f er den frame hvori informationen om hvilke specs der er valgt for folk vises



-- f:SetCallback("OnClose",function(widget) AceGUI:Release(widget) end);

f:SetCallback("OnClose",f:Hide());
f:SetTitle("myRaidAddon");
f:SetStatusText("Raid max: Empty - Raid current: - Empty");
f:SetLayout("Flow");
f:SetWidth(600);

fscroll:SetFullWidth(true);
fscroll:SetAutoAdjustHeight(true)

f:AddChild(fscroll);

-- Options
local options = { 
    name = "myRaidAddon",
    handler = myRaidAddon,
    type = "group",
    args = {
        num_tanks = {
            type = "range",
            name = "Number of tanks",
            desc = "The number of tanks you are aiming for in your raid",
            min = 1,
            max = 10,
			step = 1,
			get = function(info) return myRaidAddon.raid_num_tanks end,
			set = function(info,val) myRaidAddon.raid_num_tanks = val end,
        },
        num_healers = {
            type = "range",
            name = "Number of healers",
            desc = "The number of healers you are aiming for in your raid",
            min = 1,
            max = 10,
			step = 1,
			get = function(info) return myRaidAddon.raid_num_healers end,
			set = function(info,val) myRaidAddon.raid_num_healers = val end,
        },
		min_level = {
            type = "range",
            name = "Minimum level",
            desc = "Minimum level to join raid",
            min = 1,
            max = 80,
			step = 1,
			get = function(info) return myRaidAddon.raid_min_level end,
			set = function(info,val) myRaidAddon.raid_min_level = val end,
        },
		print_raid={
			type = "execute",
			name = "Raid data",
			desc = "Prints the raid data to console",
			func = function() for k,v in pairs(raid_data) do for i=1,#v do myRaidAddon:Print(k,v[i]); end end end,	
		},
		inc= {
			type="toggle",
			name="Show incoming requests",
			desc="Show incoming requests",
			get=function() return self.db.realm.showrequests end,
			set=function(v) self.db.realm.showrequests = v end,
			order=2,
		},
		out= {
			type="toggle",
			name="Show your replies",
			desc="Show your replies",
			get=function() return self.db.realm.showanswers end,
			set=function(v) self.db.realm.showanswers = v end,
			order=3,
		},
		guildchat= {
			type="toggle",
			name="Monitor Guildchat",
			desc="Monitor Guildchat (replies are whispered back)",
			get=function() return self.db.realm.guildactive end,
			set=function(v) self.db.realm.guildactive = v end,
			order=5,
		},
		whispers= {
			type="toggle",
			name="Monitor Whispers",
			desc="Monitor Whispers (replies are whispered back)",
			get=function() return self.db.realm.whispactive end,
			set=function(v) self.db.realm.whispactive = v end,
			order=5,
		},
		frame = {
			type = "execute",
			name = "Show RAID frame",
			desc = "Open settings frame.",
			func = "GetFrame",
		},
		populateframe2 = {
            type = "execute",
            name = "TEST: Add DPS",
            desc = "TESTING BUTTON.",
			func = "AddDPS",
        },
		populateframe3 = {
            type = "execute",
            name = "TEST: Add DPS / TANK",
            desc = "TESTING BUTTON.",
			func = "AddDPSTANK",
        },
		populateframe4 = {
            type = "execute",
            name = "TEST: Add DPS / HEAL",
            desc = "TESTING BUTTON.",
			func = "AddDPSHEAL",
        },
		populateframe5 = {
            type = "execute",
            name = "TEST: HEAL",
            desc = "TESTING BUTTON.",
			func = "AddHEAL",
        },
		populateframe6 = {
            type = "execute",
            name = "TEST: TANK",
            desc = "TESTING BUTTON.",
			func = "AddTANK",
        },
		populateframe7 = {
            type = "execute",
            name = "TEST: TANK / HEAL",
            desc = "TESTING BUTTON.",
			func = "AddTANKHEAL",
        },
    },
}


function myRaidAddon:GetArgs(text, separator)
	local args = {}
	local i = 0
	for value in string.gmatch(text, "[^"..separator.."]+") do
		i = i + 1
		args[i] = value
	end	
	return args
end

function myRaidAddon:SendResults(message,sender,source)
	
	-- Source is guild
	if source=="guild" then
		-- Do stuff, perhaps reply a short reply on guildchannel
	
		self:Respond(message,sender)
	-- Source is whisper
	else
		self:Respond(message,sender)
		
	end
end

function myRaidAddon:TableToString(table)
	if #table==0 then return end
	local result=table[1]
	if #table > 1 then
		for i=2,#table do
			result=result.." "..table[i]
		end
	end
	return result
end

function myRaidAddon:RecomposeLink(argument)
	local message=argument
	for k,v in pairs(message) do
		if strfind(v,"|cff") then
			if strfind(v,"|h|r") then 
				return message
			else 
				message[k]=v.." "..message[k+1]
				table.remove(message,k+1)
				return RecomposeLink(message)
			end
		end
	end
	return message
end

function myRaidAddon:removeElement(element)
	raid_data[element]=nil
end

function myRaidAddon:containsElement(table, element)
	for key,value in pairs(table) do
		if value == element then		
			return true
		end		
	end	
	return false
end

-- Compose reply, source is guild/whisper and arg1: message, arg2: author, arg6: flag{afk,dnd}
function myRaidAddon:QueryProcess(arg1,arg2,arg6,source)	
	local argum = self:GetArgs(arg1," ")
	local sender = arg2
	local firstword = argum[1]
	table.remove(argum,1)
	argum=self:RecomposeLink(argum)

	if not arg1 then
		return
	end
	
	-- PREFIX CHECK
	-- If there is no first word, or the word is blanks or the word is not our prefix, return and do nothing
	if not firstword or firstword:trim() == "" or not (firstword == prefix_whispers) then
		return
	end	
	
	-- compose message
	local message = "";

	local secondword = argum[1]
	table.remove(argum,1)
	argum=self:RecomposeLink(argum)
	
	-- KEYWORD CHECK
	-- If there is no second word, or the word is blanks or the word is not one of our prefixes, reply with faulty message and move on
	if not secondword or secondword:trim() == "" or not self:containsElement(keywords,secondword) then
		message = "Usage: \"!raidinfo \[register,unregister\]\"";			
		self:SendResults(message, sender,source)
		return
	end	
	
	-- KEYWORD: REGISTER
	if secondword == keywords[1] then
		-- We found the keyword register in the message
				
		local thirdword = argum[1]
		-- table.remove(argum,1)
		argum=self:RecomposeLink(argum)
		
		-- CONTENT CHECK
		-- If there is no third word, or the word is blanks or the word is not a known contentword, reply with faulty message and move on
		if not thirdword or thirdword:trim() == "" then
			message = "Usage: \"!raidinfo register \[dps,tank,heal\]\". Example: \"!raidinfo register dps,heal\" will register you to the raid being able to both dps and heal";
			self:SendResults(message, sender,source)
			return
		end	
		
		string = self:TableToString(argum)
		
		local message = "You have been registered to the raid as: ";
		local tank = false
		local dps = false
		local heal = false
		
		if string.find(string,"tank") then
			message = message.."tank"
			tank = true;
		end
		if string.find(string, "dps") then
			if tank then
				message = message..", "
			end
			message = message.."dps"
			dps = true
		end
		if string.find(string, "heal") then
			if tank or dps then
				message = message..", "
			end
			message = message.."healer"
			heal = true
		end	
			
		if not (tank or dps or heal) then
			message = "You didn't list any specs to register with. Example of usage: \"!raidinfo register dps,heal\"";
			self:SendResults(message, sender,source)
			return
		end			
		
		-- Need check to see if one or more of the specs registered are usable
		
		
		self:addPerson(arg2, tank, heal, dps)
		self:SendResults(message, sender,source)
		return		
	-- KEYWORd: UNREGISTER		
	elseif secondword == keywords[2] then			
		
		message = "You have unregistered from the raid. Have a good day";
		self:removePerson(arg2)
		self:SendResults(message, sender,source)
		return
	else
	
	
	end
end



function myRaidAddon:removePerson(name)
	self:removeElement(name);
	
	UninviteUnit(name)
	
	self:UpdateFrame();
end

function myRaidAddon:addPerson(name,tank,healer,dps)
	
	if not name then	
		name = "Test"..test_num;
		test_num = test_num + 1;
	else
		
	end
	raid_data[name] = {tank,healer,dps}
	
	-- Lav check for om vi allerede er I raid eller ej
	
	-- Lav check for om vedkommende accepteres eller ej
	
	if UnitName(name) then
		InviteUnit(name);
	end
	
	self:UpdateFrame();
end

function myRaidAddon:AddDPS(name)
	self:addPerson(nil,false,false,true);
end

function myRaidAddon:AddDPSTANK(name)
	self:addPerson(nil,true, false, true);
end

function myRaidAddon:AddDPSHEAL(name)
	self:addPerson(nil,false, true, true);
end

function myRaidAddon:AddHEAL(name)
	self:addPerson(nil,false, true, false);
end

function myRaidAddon:AddTANK(name)
	self:addPerson(nil,true, false, false);
end

function myRaidAddon:AddTANKHEAL(name)
	self:addPerson(nil,true, true, false);
end

local defaults = {
	realm = {
		showrequests=true,
		showanswers=true,
		guildactive=true,
		whispactive=true,
	}
}


function myRaidAddon:OnInitialize()
    LibStub("AceConfig-3.0"):RegisterOptionsTable("myRaidAddon", options, {"myraidaddon", "mra"})
	-- Assuming the .toc says ## SavedVariables: myRaidAddonDB
	self.db = LibStub("AceDB-3.0"):New("myRaidAddonDB", defaults, true)
    self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("myRaidAddon", "myRaidAddon")
    self:RegisterChatCommand("myraidaddon", "ChatCommand")
    self:RegisterChatCommand("mra", "ChatCommand")
	self:UpdateFrame();
end

function myRaidAddon:UpdateFrame()

	-- Fjern alle children:
	fscroll:ReleaseChildren();
	max_tanks = 0;
	max_healers = 0;
	max_dps = 0;

	for k,v in pairs(raid_data) do
		raid_line = AceGUI:Create("SimpleGroup");
		raid_line:SetLayout("Flow");
		raid_line:SetRelativeWidth(1);	

		-- Navn
		l = AceGUI:Create("Label");
		l:SetText(k);	
		l:SetWidth(name_width);
		raid_line:AddChild(l);

				
		-- tristate skal bruges til at vise specs som er mulige men ikke 'bruges' pt.
		-- tristate (boolean) unchecked (false), checked (true), greyed (nil) 
		-- Mangler: Logik til 'greyed' istedet for 'checked' 
		-- Tank
		c = AceGUI:Create("CheckBox");
		c:SetType("checkbox");
		c:SetWidth(spec_width);
		c:SetDisabled(true);
		c:SetTriState(true);
		if(v[1]) then max_tanks = max_tanks + 1; end
		c:SetValue(v[1]);
		raid_line:AddChild(c);		

		-- Heal
		c2 = AceGUI:Create("CheckBox");
		c2:SetType("checkbox");
		c2:SetWidth(spec_width);
		c2:SetDisabled(true);		
		c2:SetTriState(true);
		if(v[2]) then max_healers = max_healers + 1; end
		c2:SetValue(v[2]);
		raid_line:AddChild(c2);		
		
		-- DPS
		c3 = AceGUI:Create("CheckBox");
		c3:SetType("checkbox");
		c3:SetWidth(spec_width);
		c3:SetDisabled(true);
		c3:SetTriState(true);
		if(v[3]) then max_dps = max_dps + 1; end
		c3:SetValue(v[3]);				
		raid_line:AddChild(c3);	
		
		fscroll:AddChild(raid_line);	
	end	
	
	-- Update raid status:
	f:SetStatusText("Raid max: ("..max_tanks.." | "..max_healers.." | "..max_dps..") - Raid current: - Empty");

end

-- man skal ikke se al ingoing chat
local function filter_whisper(arg1)
	if (not self.db.realm.showrequests) then
		if (string.sub(arg1,1,string.len(prefix_whispers))==prefix_whispers) then return true end
	end
	return false, nil
end
-- man skal ikke se al outgoing chat
local function filter_whisper_inform(arg1)
	if (not self.db.realm.showanswers) then
		if (string.sub(arg1,1,string.len(prefix_answers))==prefix_answers) then return true end
	end
	return false, nil
end

function myRaidAddon:OnEnable()
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", filter_whisper)
	ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", filter_whisper_inform)
	self:RegisterEvent("CHAT_MSG_WHISPER");
	self:RegisterEvent("CHAT_MSG_GUILD");
    f:Hide();
end

function myRaidAddon:OnDisable()
	ChatFrame_RemoveMessageEventFilter("CHAT_MSG_WHISPER", filter_whisper)
	ChatFrame_RemoveMessageEventFilter("CHAT_MSG_WHISPER_INFORM", filter_whisper_inform)
	f:Hide();
    self:UnregisterEvent("CHAT_MSG_WHISPER");
	self:UnregisterEvent("CHAT_MSG_GUILD");
	self:UnhookAll();
end

function myRaidAddon:GetFrame()
    f:Show();
end

function myRaidAddon:Respond(message, sender)
	if not sender then return end
	if not message then 
		return 	
	end
	if message:trim() == "" then
		return
	end
	if message:find("^%s%S+>") then
		ChatThrottleLib:SendChatMessage("NORMAL", prefix_answers, message, "WHISPER", nil, sender)
	else
		ChatThrottleLib:SendChatMessage("NORMAL", prefix_answers, format("%s %s",prefix_answers,message), "WHISPER", nil, sender)
	end
end

function myRaidAddon:ChatCommand(input)
    if not input or input:trim() == "" then
        InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
    else
        LibStub("AceConfigCmd-3.0").HandleCommand(myRaidAddon, "mra", "myRaidAddon", input)
    end
end

function myRaidAddon:CHAT_MSG_GUILD()
	if self.db.realm.guildactive then 
		self:QueryProcess(arg1,arg2,arg6,"guild")
	end
end
function myRaidAddon:CHAT_MSG_WHISPER()
	if self.db.realm.whispactive then 
		self:QueryProcess(arg1,arg2,arg6,"whisper") 
	end
end
